Logfx <-
function(gt,X,epsilon,alpha1,beta01,alpha2,beta02, MacMin)
    {
      M<-length(gt)
      T<-dim(X)[1]
      n<-dim(X)[3]
      logfx<-array(0,c(T,n,M))
      nt<-apply(X,c(1,3),sum)
      facnt<-unlist(lapply(nt,elnfac))
      facx1<-unlist(lapply(X[,1,],elnfac))
      facx2<-unlist(lapply(X[,2,],elnfac))
      logfacConst<-matrix(facnt-facx1-facx2,T,n)
      for (i in 1:M)  
      {
        if (gt[i]==1) ## AA
        { pt<-1-epsilon
          logfx[,,i]<-matrix(unlist(lapply(pmax(dbinom(X[,1,],size=nt, prob=pt),MacMin),eln)),T,n)}
        if (gt[i]==2) ## AT-NASE
        { pt<-0.5
          logfx[,,i]<-matrix(unlist(lapply(pmax(dbinom(X[,1,],size=nt, prob=pt),MacMin),eln)),T,n)}
        if (gt[i]==3) ## AT-ASE-HIGH
        { logtemp<-LogCzero(alpha1,beta01,"H",epsilon,X)
         # class(logtemp)<-"numeric"
          logfx[,,i]<-logfacConst+logtemp-log(beta(alpha1,beta01))+(alpha1+beta01-1)*log(2)}
        if (gt[i]==4) ## AT-ASE-LOW
        { logtemp<-LogCzero(alpha2,beta02,"L",epsilon,X)
        #  class(logtemp)<-"numeric"
          logfx[,,i]<-logfacConst+logtemp-log(beta(alpha2,beta02))+(alpha2+beta02-1)*log(2)}
        if (gt[i]==5) ## TT
        { pt<-epsilon
          logfx[,,i]<-matrix(unlist(lapply(pmax(dbinom(X[,1,],size=nt, prob=pt),MacMin),eln)),T,n)}  
      }  
      return(logfx)	
    }
