\name{membership}
\alias{membership}
\title{
membership function.
}
\description{
membership() divides the total data set into several small pieces.
Each piece contains at least one SNP with genotype from SNP chip data,
which is considered as a "gold standard" in this our real data analysis.
Only useful in the example data. For general use, see membershipc(). 
}
\usage{
membership(alc, maxdist, minsnp)
}
\examples{
## The function is currently defined as
function (alc, maxdist, minsnp) 
{
    memb <- rep(0, nrow(alc))
    mdi <- maxdist
    ns <- c(NULL, NULL)
    psts <- alc[alc[, 53], 2]
    j <- 0
    for (i in psts) {
        j <- j + 1
        dst <- alc[, 2] - i
        repeat {
            selected <- abs(dst) < mdi
            if (sum(selected) >= minsnp) {
                break
            }
            else {
                mdi <- mdi + 1000
            }
        }
        ns <- rbind(ns, c(sum(selected), mdi))
        mdi <- maxdist
        memb[selected] <- j
    }
    return(list(ns, memb))
  }
}

